package top.lifuquan.controller;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import top.lifuquan.pojo.CustomerServiceTerminalInfo;
import top.lifuquan.pojo.G5TerminalInfo;
import top.lifuquan.pojo.VolteTerminalInfo;
import top.lifuquan.service.TerminalInfoService;
import top.lifuquan.vo.G5TerminalInfoVo;
import top.lifuquan.vo.R;
import top.lifuquan.vo.TerminalInfoVo;
import top.lifuquan.vo.VolteTerminalInfoVo;

import javax.annotation.Resource;
import java.text.ParseException;

@Controller
@RequestMapping("terminal")
public class TerminalInfoController {

    @Resource
    private TerminalInfoService service;

    @ResponseBody
    @RequestMapping(value = "info", method = RequestMethod.POST)
    public R getTerminalInfo(@RequestParam String phoneNumber) {
        G5TerminalInfo g5TerminalInfo = service.find5GInfoByPhoneNumber(phoneNumber);
        VolteTerminalInfo volteTerminalInfo = service.findVolteInfoByPhoneNumber(phoneNumber);
        CustomerServiceTerminalInfo customerServiceTerminalInfo = service.getCustomerServiceTerminalInfoByPhoneNumber(phoneNumber);

        // 包装TerminalInfoVO
        TerminalInfoVo infoVo = new TerminalInfoVo();
        infoVo.setMsisdn(phoneNumber);
        if (customerServiceTerminalInfo != null) {
            infoVo.setFactName(customerServiceTerminalInfo.getBrand());
            infoVo.setTerminalName(customerServiceTerminalInfo.getProduct());
            infoVo.setSubcategory(customerServiceTerminalInfo.getSubcategory());
            infoVo.setNetType(customerServiceTerminalInfo.getNetType());
        }
        if (volteTerminalInfo != null) {
            VolteTerminalInfoVo volteTerminalInfoVo = new VolteTerminalInfoVo(volteTerminalInfo);
            infoVo.setFactName(volteTerminalInfoVo.getFactName());
            infoVo.setTerminalName(volteTerminalInfoVo.getTerminalName());
            infoVo.setIsVolte(volteTerminalInfoVo.getIsVolte());
        }
        if (g5TerminalInfo != null) {
            G5TerminalInfoVo g5TerminalInfoVo = new G5TerminalInfoVo(g5TerminalInfo);
            infoVo.setFactName(g5TerminalInfoVo.getFactName());
            infoVo.setTerminalName(g5TerminalInfoVo.getTerminalName());
            infoVo.setStatus5g(g5TerminalInfoVo.getStatus5g());
            infoVo.setUsed5g(g5TerminalInfoVo.getUsed5g());
        }
        return R.ok().data("data", infoVo);
    }

    @ResponseBody
    @RequestMapping(value = "volte", method = RequestMethod.POST)
    public R getVoLteTerminalInfo(@RequestParam String phoneNumber) throws ParseException {
        VolteTerminalInfo volteTerminalInfo = service.findVolteInfoByPhoneNumber(phoneNumber);
        if (volteTerminalInfo != null) {
            return R.ok().data("data", new VolteTerminalInfoVo(volteTerminalInfo));
        }
        return R.error().message("未找到该号码VoLte相关终端信息！！");
    }

    @ResponseBody
    @RequestMapping(value = "5g", method = RequestMethod.POST)
    public R get5GTerminalInfo(@RequestParam String phoneNumber) throws ParseException {
        G5TerminalInfo terminalInfo = service.find5GInfoByPhoneNumber(phoneNumber);
        if (terminalInfo != null) {
            return R.ok().data("data", new G5TerminalInfoVo(terminalInfo));
        }
        return R.error().message("未找到该号码5G相关终端信息！！");
    }
}
