package top.lifuquan.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import top.lifuquan.dao.TaskRecordDao;
import top.lifuquan.pojo.TaskRecord;

@Service
public class TaskRecordService extends ServiceImpl<TaskRecordDao, TaskRecord> {

    /**
     * 查询某类型的某天的任务记录
     *
     * @param taskType 任务类型
     * @param taskDate 任务时间
     * @return 任务记录
     */
    public TaskRecord getRecord(String taskType, String taskDate) {
        TaskRecord taskRecord = new TaskRecord();
        taskRecord.setTaskType(taskType);
        taskRecord.setTaskDate(taskDate);
        TaskRecord record = getOne(new QueryWrapper<>(taskRecord));
        if (record != null) {
            // 记录已存在，直接返回
            return record;
        } else {
            // 记录不存在，保存一条记录
            taskRecord.setTaskStatus("任务开始");
            return taskRecord;
        }
    }
}
