package top.lifuquan.service;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;
import top.lifuquan.dao.G5TerminalInfoDao;
import top.lifuquan.dao.VolteTerminalInfoDao;
import top.lifuquan.pojo.CustomerServiceTerminalInfo;
import top.lifuquan.pojo.G5TerminalInfo;
import top.lifuquan.pojo.VolteTerminalInfo;

import javax.annotation.Resource;
import java.text.SimpleDateFormat;
import java.util.Date;

@Service
public class TerminalInfoService {

    @Resource
    private VolteTerminalInfoDao volteTerminalInfoDao;

    @Value("${t2.apiServer:192.168.70.130:12088}")
    private String apiServer;

    @Resource
    private G5TerminalInfoDao g5TerminalInfoDao;

    public VolteTerminalInfo findVolteInfoByPhoneNumber(String phoneNumber) {
        VolteTerminalInfo info = new VolteTerminalInfo();
        info.setMsisdn(phoneNumber);
        return volteTerminalInfoDao.selectOne(Wrappers.query(info));
    }

    public G5TerminalInfo find5GInfoByPhoneNumber(String phoneNumber) {
        G5TerminalInfo info = new G5TerminalInfo();
        info.setMsisdn(phoneNumber);
        return g5TerminalInfoDao.selectOne(Wrappers.query(info));
    }

    public CustomerServiceTerminalInfo getCustomerServiceTerminalInfoByPhoneNumber(String phoneNumber) {
        RestTemplate template = new RestTemplate();
        SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd+HH:mm:00");
        Date today = new Date();
        Date yesterday = new Date(today.getTime() - 1000 * 3600 * 24);
        String sdate = format.format(yesterday);
        String edate = format.format(today);

        String url = "http://" + apiServer + "/api/customer/getPhoneInfo?sdate="
                + sdate
                + "&edate="
                + edate
                + "&phone="
                + phoneNumber
                + "&module=0&is5GFlag=0&limitSpeed=0&uuidExcel=&lon=&lat=";

        JSONObject jsonObject = template.postForObject(url, "", JSONObject.class);
        if (jsonObject != null && jsonObject.getString("msg").equals("请求成功")) {
            jsonObject = jsonObject.getJSONObject("data");
            CustomerServiceTerminalInfo info = new CustomerServiceTerminalInfo();
            info.setMsisdn(phoneNumber);
            info.setBrand(jsonObject.getString("brand"));
            info.setProduct(jsonObject.getString("product"));
            info.setSubcategory(jsonObject.getString("subcategory"));
            info.setNetType(jsonObject.getString("nettype"));
            return info;
        }
        return null;
    }

}
