package top.lifuquan.vo;

import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import top.lifuquan.pojo.G5TerminalInfo;

@Data
@TableName("tmlq.o_info_list_5g_terminal")
public class G5TerminalInfoVo {
    private String msisdn;
    /**
     * 字段说明：
     * 在统计时段内，用户是否接入过5G网络
     * 0：未登网   1：登网
     */
    private String used5g;
    /**
     * 字段说明：
     * 统计当天5G开关是否曾打开
     * true：打开   false：未打开
     */
    private String status5g;
    private String day;
    private String factName;
    private String terminalName;

    public G5TerminalInfoVo(G5TerminalInfo terminalInfo) {
        this.msisdn = terminalInfo.getMsisdn();
        this.used5g = terminalInfo.getUsed5g().equals(1) ? "使用过5G网络" : "未使用5G网络";
        this.status5g = terminalInfo.getStatus5g().equals("true") ? "5G开关打开" : "5G终端未打开";
        this.day = terminalInfo.getDay();
        this.factName = terminalInfo.getFactName();
        this.terminalName = terminalInfo.getTerminalName();
    }
}
