package top.lifuquan.vo;

import lombok.Data;
import top.lifuquan.pojo.VolteTerminalInfo;

@Data
public class VolteTerminalInfoVo {

    private String msisdn;
    /**
     * 字段说明：
     * 硬件无法识别：-3
     * 其它终端硬件支持但无法识别软件是否支持或开关是否打开：-2
     * 苹果终端硬件支持但无法识别软件是否支持或开关是否打开：-1
     * 硬件不支持：0
     * 硬件支持软件不支持：1
     * 硬件软件支持但开关未打开：2
     * 硬件软件支持且开关打开：3
     */
    private String isVolte;
    private String dayDate;
    private String factName;
    private String terminalName;
    private String hprovinceName;

    public VolteTerminalInfoVo(VolteTerminalInfo volteTerminalInfo) {
        this.msisdn = volteTerminalInfo.getMsisdn();
        switch (volteTerminalInfo.getIsVolte()) {
            case -3:
                this.isVolte = "硬件无法识别，不做参考";
                break;
            case -2:
                this.isVolte = "其它终端硬件支持但无法识别软件是否支持或开关是否打开，建议用户尝试升级系统版本或打开volte开关";
                break;
            case -1:
                this.isVolte = "苹果终端硬件支持但无法识别软件是否支持或开关是否打开，建议用户尝试升级系统版本或打开volte开关";
                break;
            case 0:
                this.isVolte = "硬件不支持，用户无法使用volte功能，转向2/3G语音流程";
                break;
            case 1:
                this.isVolte = "硬件支持软件不支持，建议用户升级系统版本";
                break;
            case 2:
                this.isVolte = "硬件软件支持但开关未打开,建议用户打开volte开关";
                break;
            case 3:
                this.isVolte = "硬件软件支持且开关打开，可正常使用volte功能";
                break;
            default:
                this.isVolte = "出现未定义值，请记下号码并通知管理员";
        }

        this.dayDate = volteTerminalInfo.getDayDate();
        this.factName = volteTerminalInfo.getFactName();
        this.terminalName = volteTerminalInfo.getTerminalName();
        this.hprovinceName = volteTerminalInfo.getHprovinceName();
    }
}
